/****************************************************************************
** $Id: qsinterfacefactory_p.h  20030513   edited May 9 12:55 $
**
** Copyright (C) 2001-2003 Trolltech AS.  All rights reserved.
**
** This file is part of the Qt Script for Applications framework (QSA).
**
** This file may be distributed and/or modified under the terms of the
** GNU General Public License version 2 as published by the Free Software
** Foundation and appearing in the file LICENSE.GPL included in the
** packaging of this file.
**
** Licensees holding a valid QSA Beta Evaluation Version license may use
** this file in accordance with the QSA Beta Evaluation Version License
** Agreement provided with the Software.
**
** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
**
** See http://www.trolltech.com/pricing.html or email sales@trolltech.com for
**   information about QSA Commercial License Agreements.
** See http://www.trolltech.com/gpl/ for GPL licensing information.
**
** Contact info@trolltech.com if any conditions of this licensing are
** not clear to you.
**
*****************************************************************************/

#ifndef QSINTERFACEFACTORY_P_H
#define QSINTERFACEFACTORY_P_H

#include <quickdispatchobject.h>
#include <qsobjectfactory.h>
#include <qswrapperfactory.h>
#include <qmap.h>
#include <qptrlist.h>

class QSInterfaceFactory : public QuickDispatchObjectFactory
{
public:
    QSInterfaceFactory( QSInterpreter *i );
    virtual ~QSInterfaceFactory() {}

    bool isConstructor( const QString &className ) const;

    QMap<QString,QString> instanceDescriptors() const;
    QMap<QString,QObject*> staticDescriptors() const;

    void addConstructor( QSObjectFactory *ctor );
    void addWrapper( QSWrapperFactory *w );

protected:
    bool createInterface( const QCString &className, void *ptr );
    bool createInstance( const QString &className,
			 const QValueList<QVariant> &args );
private:
    void createClassList();

private:
    QSInterpreter *interp;
    QPtrList<QSObjectFactory> ctors;
    QPtrList<QSWrapperFactory> wrappers;
    bool dirty;
    QMap<QString, QString> instDescr;
    QMap<QString, QObject*> statDescr;
    QMap<QString, QSObjectFactory*> objectFactoryCache;
    QMap<QString, QSWrapperFactory*> wrapperFactoryCache;

};

#endif
